IMPLEMENTATION MODULE IOSupport;

FROM Transition IMPORT OCTET;
IMPORT ChanIO, StdIO;


IMPORT BooleanBaseIO, BooleanArrayIO;
(* Imports IO modules for predefined type BOOLEAN into the importing module. *)
IMPORT CharBaseIO, CharArrayIO, CharStrIO;
(* Imports IO modules for predefined type CHAR into the importing module. *)
IMPORT OctetBaseIO, OctetArrayIO;
(* Imports IO modules for predefined type OCTET into the importing module. *)
IMPORT CardinalBaseIO, CardinalArrayIO;
(* Imports IO modules for predefined type CARDINAL into the importing module. *)
IMPORT LongCardBaseIO, LongCardArrayIO;
(* Imports IO modules for predefined type LONGCARD into the importing module. *)
IMPORT IntegerBaseIO, IntegerArrayIO;
(* Imports IO modules for predefined type INTEGER into the importing module. *)
IMPORT LongIntBaseIO, LongIntArrayIO;
(* Imports IO modules for predefined type LONGINT into the importing module. *)
IMPORT RealBaseIO, RealArrayIO;
(* Imports IO modules for predefined type REAL into the importing module. *)
IMPORT LongRealBaseIO, LongRealArrayIO;
(* Imports IO modules for pervasive type LONGREAL into the importing module. *)


(* In what follows, we define the other simple procs, that is, the ones with the default channels
  All this can go away when we have the real thing. *)

(* Boolean section *)
PROCEDURE ReadBoolean ( VAR b : BOOLEAN);

BEGIN
  BooleanBaseIO.Read (StdIO.in(), b)
END ReadBoolean;


PROCEDURE WriteBoolean ( b : BOOLEAN);

BEGIN
  BooleanBaseIO.Write (StdIO.out(), b)
END WriteBoolean;


PROCEDURE WriteFBoolean ( fmtArray : ARRAY OF CHAR; bools : ARRAY OF BOOLEAN);

BEGIN
  BooleanBaseIO.WriteF (StdIO.out(), fmtArray, bools)
END WriteFBoolean;

(* What comes after is Kludge to allow easy access to WriteF *)

PROCEDURE Write1FBoolean ( fmtStr : ARRAY OF CHAR; item : BOOLEAN );
BEGIN
  BooleanBaseIO.Write1F ( StdIO.out(), fmtStr, item )
END Write1FBoolean;

PROCEDURE Write2FBoolean (fmtStr : ARRAY OF CHAR; item1, item2 : BOOLEAN );

BEGIN
  BooleanBaseIO.Write2F (StdIO.out(), fmtStr, item1, item2 )
END Write2FBoolean;

PROCEDURE Write3FBoolean ( fmtStr : ARRAY OF CHAR; item1, item2, item3 : BOOLEAN );
BEGIN
  BooleanBaseIO.Write3F (StdIO.out(), fmtStr, item1, item2, item3 )
END Write3FBoolean;

  (* end Kludge *)

PROCEDURE ReadBooleanArray ( VAR bools : ARRAY OF BOOLEAN );

BEGIN
  BooleanArrayIO.ReadArray (StdIO.in(), bools)
END ReadBooleanArray;


PROCEDURE WriteBooleanArray ( bools : ARRAY OF BOOLEAN);

BEGIN
  BooleanArrayIO.WriteArray (StdIO.out(), bools)
END WriteBooleanArray;


PROCEDURE WriteFBooleanArray ( fmtArray : ARRAY OF CHAR; bools : (*ARGLIST >0*) ARRAY OF ARRAY OF BOOLEAN );

BEGIN
  BooleanArrayIO.WriteFArray (StdIO.out(), fmtArray, bools)
END WriteFBooleanArray;

(* End Boolean section *)

(* Octet section *)


PROCEDURE ReadOctet ( VAR oct : OCTET);

BEGIN
  OctetBaseIO.Read (StdIO.in(), oct)
END ReadOctet;


PROCEDURE WriteOctet ( oct : OCTET);

BEGIN
  OctetBaseIO.Write (StdIO.out(), oct)
END WriteOctet;


PROCEDURE WriteFOctet ( fmtArray : ARRAY OF CHAR; octets : ARRAY OF OCTET);

BEGIN
  OctetBaseIO.WriteF (StdIO.out(), fmtArray, octets)
END WriteFOctet;


(* What comes after is Kludge to allow easy access to WriteF *)

PROCEDURE Write1FOctet ( fmtStr : ARRAY OF CHAR; item : OCTET );
BEGIN
  OctetBaseIO.Write1F ( StdIO.out(), fmtStr, item )
END Write1FOctet;

PROCEDURE Write2FOctet (fmtStr : ARRAY OF CHAR; item1, item2 : OCTET );

BEGIN
  OctetBaseIO.Write2F (StdIO.out(), fmtStr, item1, item2 )
END Write2FOctet;

PROCEDURE Write3FOctet ( fmtStr : ARRAY OF CHAR; item1, item2, item3 : OCTET );
BEGIN
  OctetBaseIO.Write3F (StdIO.out(), fmtStr, item1, item2, item3 )
END Write3FOctet;

  (* end Kludge *)


PROCEDURE ReadOctetArray ( VAR octets : ARRAY OF OCTET );

BEGIN
  OctetArrayIO.ReadArray (StdIO.in(), octets)
END ReadOctetArray;


PROCEDURE WriteOctetArray ( octets : ARRAY OF OCTET);

BEGIN
  OctetArrayIO.WriteArray (StdIO.out(), octets)
END WriteOctetArray;


PROCEDURE WriteFOctetArray ( fmtArray : ARRAY OF CHAR; octets : (*ARGLIST >0*) ARRAY OF ARRAY OF OCTET );

BEGIN
  OctetArrayIO.WriteFArray (StdIO.out(), fmtArray, octets)
END WriteFOctetArray;

(*End Octet section *)

(* Cardinal section *)


PROCEDURE ReadCardinal ( VAR n : CARDINAL);

BEGIN
  CardinalBaseIO.Read (StdIO.in(), n)
END ReadCardinal;


PROCEDURE WriteCardinal ( n : CARDINAL);

BEGIN
  CardinalBaseIO.Write (StdIO.out(), n)
END WriteCardinal;


PROCEDURE WriteFCardinal ( fmtArray : ARRAY OF CHAR; cards : ARRAY OF CARDINAL);

BEGIN
  CardinalBaseIO.WriteF (StdIO.out(), fmtArray, cards)
END WriteFCardinal;

(* What comes after is Kludge to allow easy access to WriteF *)

PROCEDURE Write1FCardinal ( fmtStr : ARRAY OF CHAR; item : CARDINAL );
BEGIN
  CardinalBaseIO.Write1F ( StdIO.out(), fmtStr, item )
END Write1FCardinal;

PROCEDURE Write2FCardinal (fmtStr : ARRAY OF CHAR; item1, item2 : CARDINAL );

BEGIN
  CardinalBaseIO.Write2F (StdIO.out(), fmtStr, item1, item2 )
END Write2FCardinal;

PROCEDURE Write3FCardinal ( fmtStr : ARRAY OF CHAR; item1, item2, item3 : CARDINAL );
BEGIN
  CardinalBaseIO.Write3F (StdIO.out(), fmtStr, item1, item2, item3 )
END Write3FCardinal;

  (* end Kludge *)

PROCEDURE ReadCardinalArray ( VAR cards : ARRAY OF CARDINAL );

BEGIN
  CardinalArrayIO.ReadArray (StdIO.in(), cards)
END ReadCardinalArray;


PROCEDURE WriteCardinalArray ( cards : ARRAY OF CARDINAL);

BEGIN
  CardinalArrayIO.WriteArray (StdIO.out(), cards)
END WriteCardinalArray;


PROCEDURE WriteFCardinalArray ( fmtArray : ARRAY OF CHAR; cards : (*ARGLIST >0*) ARRAY OF ARRAY OF CARDINAL );

BEGIN
  CardinalArrayIO.WriteFArray (StdIO.out(), fmtArray, cards)
END WriteFCardinalArray;

(*End Cardinal section *)

(* LongCard section *)


PROCEDURE ReadLongCard ( VAR n : LONGCARD);

BEGIN
  LongCardBaseIO.Read (StdIO.in(), n)
END ReadLongCard;


PROCEDURE WriteLongCard ( n : LONGCARD);

BEGIN
  LongCardBaseIO.Write (StdIO.out(), n)
END WriteLongCard;


PROCEDURE WriteFLongCard ( fmtArray : ARRAY OF CHAR; cards : ARRAY OF LONGCARD);

BEGIN
  LongCardBaseIO.WriteF (StdIO.out(), fmtArray, cards)
END WriteFLongCard;

(* What comes after is Kludge to allow easy access to WriteF *)

PROCEDURE Write1FLongCard ( fmtStr : ARRAY OF CHAR; item : LONGCARD );
BEGIN
  LongCardBaseIO.Write1F ( StdIO.out(), fmtStr, item )
END Write1FLongCard;

PROCEDURE Write2FLongCard (fmtStr : ARRAY OF CHAR; item1, item2 : LONGCARD );

BEGIN
  LongCardBaseIO.Write2F (StdIO.out(), fmtStr, item1, item2 )
END Write2FLongCard;

PROCEDURE Write3FLongCard ( fmtStr : ARRAY OF CHAR; item1, item2, item3 : LONGCARD );
BEGIN
  LongCardBaseIO.Write3F (StdIO.out(), fmtStr, item1, item2, item3 )
END Write3FLongCard;

  (* end Kludge *)


PROCEDURE ReadLongCardArray ( VAR cards : ARRAY OF LONGCARD );

BEGIN
  LongCardArrayIO.ReadArray (StdIO.in(), cards)
END ReadLongCardArray;


PROCEDURE WriteLongCardArray ( cards : ARRAY OF LONGCARD);

BEGIN
  LongCardArrayIO.WriteArray (StdIO.out(), cards)
END WriteLongCardArray;


PROCEDURE WriteFLongCardArray ( fmtArray : ARRAY OF CHAR; cards : (*ARGLIST >0*) ARRAY OF ARRAY OF LONGCARD );

BEGIN
  LongCardArrayIO.WriteFArray (StdIO.out(), fmtArray, cards)
END WriteFLongCardArray;

(*End LongCard section *)

(* CHAR section *)


PROCEDURE ReadChar ( VAR ch : CHAR);

BEGIN
  CharBaseIO.Read (StdIO.in(), ch)
END ReadChar;


PROCEDURE WriteChar ( ch : CHAR);

BEGIN
  CharBaseIO.Write (StdIO.out(), ch)
END WriteChar;


PROCEDURE WriteFChar ( fmtArray : ARRAY OF CHAR; str : ARRAY OF CHAR);

BEGIN
  CharBaseIO.WriteF (StdIO.out(), fmtArray, str)
END WriteFChar;


(* What comes after is Kludge to allow easy access to WriteF *)

PROCEDURE Write1FChar ( fmtStr : ARRAY OF CHAR; item : CHAR );
BEGIN
  CharBaseIO.Write1F ( StdIO.out(), fmtStr, item )
END Write1FChar;

PROCEDURE Write2FChar (fmtStr : ARRAY OF CHAR; item1, item2 : CHAR );

BEGIN
  CharBaseIO.Write2F (StdIO.out(), fmtStr, item1, item2 )
END Write2FChar;

PROCEDURE Write3FChar ( fmtStr : ARRAY OF CHAR; item1, item2, item3 : CHAR );
BEGIN
  CharBaseIO.Write3F (StdIO.out(), fmtStr, item1, item2, item3 )
END Write3FChar;

  (* end Kludge *)


PROCEDURE ReadCharArray ( VAR str : ARRAY OF CHAR );

BEGIN
  CharArrayIO.ReadArray (StdIO.in(), str)
END ReadCharArray;


PROCEDURE WriteCharArray ( str : ARRAY OF CHAR);

BEGIN
  CharArrayIO.WriteArray (StdIO.out(), str)
END WriteCharArray;


PROCEDURE WriteFCharArray ( fmtArray : ARRAY OF CHAR; strings : (*ARGLIST >0*) ARRAY OF ARRAY OF CHAR );

BEGIN
  CharArrayIO.WriteFArray (StdIO.out(), fmtArray, strings)
END WriteFCharArray;


PROCEDURE ReadCharStr ( VAR str : ARRAY OF CHAR );

BEGIN
  CharStrIO.ReadStr (StdIO.in(), str)
END ReadCharStr;


PROCEDURE WriteCharStr ( str : ARRAY OF CHAR);

BEGIN
  CharStrIO.WriteStr (StdIO.out(), str)
END WriteCharStr;


PROCEDURE WriteFCharStr ( fmtArray : ARRAY OF CHAR; strings : (*ARGLIST >0*) ARRAY OF ARRAY OF CHAR );

BEGIN
  CharStrIO.WriteFStr (StdIO.out(), fmtArray, strings)
END WriteFCharStr;

(* End CHAR section *)

(* Integer section *)


PROCEDURE ReadInteger ( VAR i : INTEGER);

BEGIN
  IntegerBaseIO.Read (StdIO.in(), i)
END ReadInteger;


PROCEDURE WriteInteger ( i : INTEGER);

BEGIN
  IntegerBaseIO.Write (StdIO.out(), i)
END WriteInteger;


PROCEDURE WriteFInteger ( fmtArray : ARRAY OF CHAR; ints : ARRAY OF INTEGER);

BEGIN
  IntegerBaseIO.WriteF (StdIO.out(), fmtArray, ints)
END WriteFInteger;


(* What comes after is Kludge to allow easy access to WriteF *)

PROCEDURE Write1FInteger ( fmtStr : ARRAY OF CHAR; item : INTEGER );
BEGIN
  IntegerBaseIO.Write1F ( StdIO.out(), fmtStr, item )
END Write1FInteger;

PROCEDURE Write2FInteger (fmtStr : ARRAY OF CHAR; item1, item2 : INTEGER );

BEGIN
  IntegerBaseIO.Write2F (StdIO.out(), fmtStr, item1, item2 )
END Write2FInteger;

PROCEDURE Write3FInteger ( fmtStr : ARRAY OF CHAR; item1, item2, item3 : INTEGER );
BEGIN
  IntegerBaseIO.Write3F (StdIO.out(), fmtStr, item1, item2, item3 )
END Write3FInteger;

  (* end Kludge *)
  
  
PROCEDURE ReadIntegerArray ( VAR ints : ARRAY OF INTEGER );

BEGIN
  IntegerArrayIO.ReadArray (StdIO.in(), ints)
END ReadIntegerArray;


PROCEDURE WriteIntegerArray ( ints : ARRAY OF INTEGER);

BEGIN
  IntegerArrayIO.WriteArray (StdIO.out(), ints)
END WriteIntegerArray;


PROCEDURE WriteFIntegerArray ( fmtArray : ARRAY OF CHAR; ints : (*ARGLIST >0*) ARRAY OF ARRAY OF INTEGER );

BEGIN
  IntegerArrayIO.WriteFArray (StdIO.out(), fmtArray, ints)
END WriteFIntegerArray;

(*End Integer section *)

(* LongInt section *)


PROCEDURE ReadLongInt ( VAR i : LONGINT);

BEGIN
  LongIntBaseIO.Read (StdIO.in(), i)
END ReadLongInt;


PROCEDURE WriteLongInt ( i : LONGINT);

BEGIN
  LongIntBaseIO.Write (StdIO.out(), i)
END WriteLongInt;


PROCEDURE WriteFLongInt ( fmtArray : ARRAY OF CHAR; ints : ARRAY OF LONGINT);

BEGIN
  LongIntBaseIO.WriteF (StdIO.out(), fmtArray, ints)
END WriteFLongInt;

(* What comes after is Kludge to allow easy access to WriteF *)

PROCEDURE Write1FLongInt ( fmtStr : ARRAY OF CHAR; item : LONGINT );
BEGIN
  LongIntBaseIO.Write1F ( StdIO.out(), fmtStr, item )
END Write1FLongInt;

PROCEDURE Write2FLongInt (fmtStr : ARRAY OF CHAR; item1, item2 : LONGINT );

BEGIN
  LongIntBaseIO.Write2F (StdIO.out(), fmtStr, item1, item2 )
END Write2FLongInt;

PROCEDURE Write3FLongInt ( fmtStr : ARRAY OF CHAR; item1, item2, item3 : LONGINT );
BEGIN
  LongIntBaseIO.Write3F (StdIO.out(), fmtStr, item1, item2, item3 )
END Write3FLongInt;

  (* end Kludge *)


PROCEDURE ReadLongIntArray ( VAR ints : ARRAY OF LONGINT );

BEGIN
  LongIntArrayIO.ReadArray (StdIO.in(), ints)
END ReadLongIntArray;


PROCEDURE WriteLongIntArray ( ints : ARRAY OF LONGINT);

BEGIN
  LongIntArrayIO.WriteArray (StdIO.out(), ints)
END WriteLongIntArray;


PROCEDURE WriteFLongIntArray ( fmtArray : ARRAY OF CHAR; ints : (*ARGLIST >0*) ARRAY OF ARRAY OF LONGINT );

BEGIN
  LongIntArrayIO.WriteFArray (StdIO.out(), fmtArray, ints)
END WriteFLongIntArray;

(*End LongInt section *)

(* Real section *)


PROCEDURE ReadReal ( VAR r : REAL);

BEGIN
  RealBaseIO.Read (StdIO.in(), r)
END ReadReal;


PROCEDURE WriteReal ( r : REAL);

BEGIN
  RealBaseIO.Write (StdIO.out(), r)
END WriteReal;


PROCEDURE WriteFReal ( fmtArray : ARRAY OF CHAR; reals : ARRAY OF REAL);

BEGIN
  RealBaseIO.WriteF (StdIO.out(), fmtArray, reals)
END WriteFReal;

(* What comes after is Kludge to allow easy access to WriteF *)

PROCEDURE Write1FReal ( fmtStr : ARRAY OF CHAR; item : REAL );
BEGIN
  RealBaseIO.Write1F ( StdIO.out(), fmtStr, item )
END Write1FReal;

PROCEDURE Write2FReal (fmtStr : ARRAY OF CHAR; item1, item2 : REAL );

BEGIN
  RealBaseIO.Write2F (StdIO.out(), fmtStr, item1, item2 )
END Write2FReal;

PROCEDURE Write3FReal ( fmtStr : ARRAY OF CHAR; item1, item2, item3 : REAL );
BEGIN
  RealBaseIO.Write3F (StdIO.out(), fmtStr, item1, item2, item3 )
END Write3FReal;

  (* end Kludge *)


PROCEDURE ReadRealArray ( VAR reals : ARRAY OF REAL );

BEGIN
  RealArrayIO.ReadArray (StdIO.in(), reals)
END ReadRealArray;


PROCEDURE WriteRealArray ( reals : ARRAY OF REAL);

BEGIN
  RealArrayIO.WriteArray (StdIO.out(), reals)
END WriteRealArray;


PROCEDURE WriteFRealArray ( fmtArray : ARRAY OF CHAR; reals : (*ARGLIST >0*) ARRAY OF ARRAY OF REAL );

BEGIN
  RealArrayIO.WriteFArray (StdIO.out(), fmtArray, reals)
END WriteFRealArray;

(*End Real section *)

(* LongReal section *)


PROCEDURE ReadLongReal ( VAR r : LONGREAL);

BEGIN
  LongRealBaseIO.Read (StdIO.in(), r)
END ReadLongReal;


PROCEDURE WriteLongReal ( r : LONGREAL);

BEGIN
  LongRealBaseIO.Write (StdIO.out(), r)
END WriteLongReal;


PROCEDURE WriteFLongReal ( fmtArray : ARRAY OF CHAR; reals : ARRAY OF LONGREAL);

BEGIN
  LongRealBaseIO.WriteF (StdIO.out(), fmtArray, reals)
END WriteFLongReal;


(* What comes after is Kludge to allow easy access to WriteF *)

PROCEDURE Write1FLongReal ( fmtStr : ARRAY OF CHAR; item : LONGREAL );
BEGIN
  LongRealBaseIO.Write1F ( StdIO.out(), fmtStr, item )
END Write1FLongReal;

PROCEDURE Write2FLongReal (fmtStr : ARRAY OF CHAR; item1, item2 : LONGREAL );

BEGIN
  LongRealBaseIO.Write2F (StdIO.out(), fmtStr, item1, item2 )
END Write2FLongReal;

PROCEDURE Write3FLongReal ( fmtStr : ARRAY OF CHAR; item1, item2, item3 : LONGREAL );
BEGIN
  LongRealBaseIO.Write3F (StdIO.out(), fmtStr, item1, item2, item3 )
END Write3FLongReal;

  (* end Kludge *)

PROCEDURE ReadLongRealArray ( VAR reals : ARRAY OF LONGREAL );

BEGIN
  LongRealArrayIO.ReadArray (StdIO.in(), reals)
END ReadLongRealArray;


PROCEDURE WriteLongRealArray ( reals : ARRAY OF LONGREAL);

BEGIN
  LongRealArrayIO.WriteArray (StdIO.out(), reals)
END WriteLongRealArray;


PROCEDURE WriteFLongRealArray ( fmtArray : ARRAY OF CHAR; reals : (*ARGLIST >0*) ARRAY OF ARRAY OF LONGREAL );

BEGIN
  LongRealArrayIO.WriteFArray (StdIO.out(), fmtArray, reals)
END WriteFLongRealArray;

(*End LongReal section *)

BEGIN (* main module *)
  (* fill in methods for the one with file params *)
  BooleanIO.Read := BooleanBaseIO.Read;
  BooleanIO.Write := BooleanBaseIO.Write;
  BooleanIO.WriteF := BooleanBaseIO.WriteF;
  BooleanIO.ReadArray := BooleanArrayIO.ReadArray;
  BooleanIO.WriteArray := BooleanArrayIO.WriteArray;
  BooleanIO.WriteFArray := BooleanArrayIO.WriteFArray;
  BooleanIO.Write1F := BooleanBaseIO.Write1F;
  BooleanIO.Write2F := BooleanBaseIO.Write2F;
  BooleanIO.Write3F := BooleanBaseIO.Write3F;

  OctetIO.Read := OctetBaseIO.Read;
  OctetIO.Write := OctetBaseIO.Write;
  OctetIO.WriteF := OctetBaseIO.WriteF;
  OctetIO.ReadArray := OctetArrayIO.ReadArray;
  OctetIO.WriteArray := OctetArrayIO.WriteArray;
  OctetIO.WriteFArray := OctetArrayIO.WriteFArray;
  OctetIO.Write1F := OctetBaseIO.Write1F;
  OctetIO.Write2F := OctetBaseIO.Write2F;
  OctetIO.Write3F := OctetBaseIO.Write3F;

  CardinalIO.Read := CardinalBaseIO.Read;
  CardinalIO.Write := CardinalBaseIO.Write;
  CardinalIO.WriteF := CardinalBaseIO.WriteF;
  CardinalIO.ReadArray := CardinalArrayIO.ReadArray;
  CardinalIO.WriteArray := CardinalArrayIO.WriteArray;
  CardinalIO.WriteFArray := CardinalArrayIO.WriteFArray;
  CardinalIO.Write1F := CardinalBaseIO.Write1F;
  CardinalIO.Write2F := CardinalBaseIO.Write2F;
  CardinalIO.Write3F := CardinalBaseIO.Write3F;

  LongCardIO.Read := LongCardBaseIO.Read;
  LongCardIO.Write := LongCardBaseIO.Write;
  LongCardIO.WriteF := LongCardBaseIO.WriteF;
  LongCardIO.ReadArray := LongCardArrayIO.ReadArray;
  LongCardIO.WriteArray := LongCardArrayIO.WriteArray;
  LongCardIO.WriteFArray := LongCardArrayIO.WriteFArray;
  LongCardIO.Write1F := LongCardBaseIO.Write1F;
  LongCardIO.Write2F := LongCardBaseIO.Write2F;
  LongCardIO.Write3F := LongCardBaseIO.Write3F;

  CharIO.Read := CharBaseIO.Read;
  CharIO.Write := CharBaseIO.Write;
  CharIO.WriteF := CharBaseIO.WriteF;
  CharIO.ReadArray := CharArrayIO.ReadArray;
  CharIO.WriteArray := CharArrayIO.WriteArray;
  CharIO.WriteFArray := CharArrayIO.WriteFArray;
  CharIO.ReadStr := CharStrIO.ReadStr;
  CharIO.WriteStr := CharStrIO.WriteStr;
  CharIO.WriteFStr := CharStrIO.WriteFStr;
  CharIO.Write1F := CharBaseIO.Write1F;
  CharIO.Write2F := CharBaseIO.Write2F;
  CharIO.Write3F := CharBaseIO.Write3F;

  IntegerIO.Read := IntegerBaseIO.Read;
  IntegerIO.Write := IntegerBaseIO.Write;
  IntegerIO.WriteF := IntegerBaseIO.WriteF;
  IntegerIO.ReadArray := IntegerArrayIO.ReadArray;
  IntegerIO.WriteArray := IntegerArrayIO.WriteArray;
  IntegerIO.WriteFArray := IntegerArrayIO.WriteFArray;
  IntegerIO.Write1F := IntegerBaseIO.Write1F;
  IntegerIO.Write2F := IntegerBaseIO.Write2F;
  IntegerIO.Write3F := IntegerBaseIO.Write3F;

  LongIntIO.Read := LongIntBaseIO.Read;
  LongIntIO.Write := LongIntBaseIO.Write;
  LongIntIO.WriteF := LongIntBaseIO.WriteF;
  LongIntIO.ReadArray := LongIntArrayIO.ReadArray;
  LongIntIO.WriteArray := LongIntArrayIO.WriteArray;
  LongIntIO.WriteFArray := LongIntArrayIO.WriteFArray;
  LongIntIO.Write1F := LongIntBaseIO.Write1F;
  LongIntIO.Write2F := LongIntBaseIO.Write2F;
  LongIntIO.Write3F := LongIntBaseIO.Write3F;

  LongRealIO.Read := LongRealBaseIO.Read;
  LongRealIO.Write := LongRealBaseIO.Write;
  LongRealIO.WriteF := LongRealIO.WriteF;
  LongRealIO.ReadArray := LongRealArrayIO.ReadArray;
  LongRealIO.WriteArray := LongRealArrayIO.WriteArray;
  LongRealIO.WriteFArray := LongRealArrayIO.WriteFArray;
  LongRealIO.Write1F := LongRealBaseIO.Write1F;
  LongRealIO.Write2F := LongRealBaseIO.Write2F;
  LongRealIO.Write3F := LongRealBaseIO.Write3F;

  RealIO.Read := RealBaseIO.Read;
  RealIO.Write := RealBaseIO.Write;
  RealIO.WriteF := RealBaseIO.WriteF;
  RealIO.ReadArray := RealArrayIO.ReadArray;
  RealIO.WriteArray := RealArrayIO.WriteArray;
  RealIO.WriteFArray := RealArrayIO.WriteFArray;
  RealIO.Write1F := RealBaseIO.Write1F;
  RealIO.Write2F := RealBaseIO.Write2F;
  RealIO.Write3F := RealBaseIO.Write3F;

  (* fill in methods for the one without file params *)
  sBooleanIO.Read := ReadBoolean;
  sBooleanIO.Write := WriteBoolean;
  sBooleanIO.WriteF := WriteFBoolean;
  sBooleanIO.ReadArray := ReadBooleanArray;
  sBooleanIO.WriteArray := WriteBooleanArray;
  sBooleanIO.WriteFArray := WriteFBooleanArray;
  sBooleanIO.Write1F := Write1FBoolean;
  sBooleanIO.Write2F := Write2FBoolean;
  sBooleanIO.Write3F := Write3FBoolean;

  sOctetIO.Read := ReadOctet;
  sOctetIO.Write := WriteOctet;
  sOctetIO.WriteF := WriteFOctet;
  sOctetIO.ReadArray := ReadOctetArray;
  sOctetIO.WriteArray := WriteOctetArray;
  sOctetIO.WriteFArray := WriteFOctetArray;
  sOctetIO.Write1F := Write1FOctet;
  sOctetIO.Write2F := Write2FOctet;
  sOctetIO.Write3F := Write3FOctet;

  sCardinalIO.Read := ReadCardinal;
  sCardinalIO.Write := WriteCardinal;
  sCardinalIO.WriteF := WriteFCardinal;
  sCardinalIO.ReadArray := ReadCardinalArray;
  sCardinalIO.WriteArray := WriteCardinalArray;
  sCardinalIO.WriteFArray := WriteFCardinalArray;
  sCardinalIO.Write1F := Write1FCardinal;
  sCardinalIO.Write2F := Write2FCardinal;
  sCardinalIO.Write3F := Write3FCardinal;

  sLongCardIO.Read := ReadLongCard;
  sLongCardIO.Write := WriteLongCard;
  sLongCardIO.WriteF := WriteFLongCard;
  sLongCardIO.ReadArray := ReadLongCardArray;
  sLongCardIO.WriteArray := WriteLongCardArray;
  sLongCardIO.WriteFArray := WriteFLongCardArray;
  sLongCardIO.Write1F := Write1FLongCard;
  sLongCardIO.Write2F := Write2FLongCard;
  sLongCardIO.Write3F := Write3FLongCard;

  sCharIO.Read := ReadChar;
  sCharIO.Write := WriteChar;
  sCharIO.WriteF := WriteFChar;
  sCharIO.ReadArray := ReadCharArray;
  sCharIO.WriteArray := WriteCharArray;
  sCharIO.WriteFArray := WriteFCharArray;
  sCharIO.ReadStr := ReadCharStr;
  sCharIO.WriteStr := WriteCharStr;
  sCharIO.WriteFStr := WriteFCharStr;
  sCharIO.Write1F := Write1FChar;
  sCharIO.Write2F := Write2FChar;
  sCharIO.Write3F := Write3FChar;

  sIntegerIO.Read := ReadInteger;
  sIntegerIO.Write := WriteInteger;
  sIntegerIO.WriteF := WriteFInteger;
  sIntegerIO.ReadArray := ReadIntegerArray;
  sIntegerIO.WriteArray := WriteIntegerArray;
  sIntegerIO.WriteFArray := WriteFIntegerArray;
  sIntegerIO.Write1F := Write1FInteger;
  sIntegerIO.Write2F := Write2FInteger;
  sIntegerIO.Write3F := Write3FInteger;

  sLongIntIO.Read := ReadLongInt;
  sLongIntIO.Write := WriteLongInt;
  sLongIntIO.WriteF := WriteFLongInt;
  sLongIntIO.ReadArray := ReadLongIntArray;
  sLongIntIO.WriteArray := WriteLongIntArray;
  sLongIntIO.WriteFArray := WriteFLongIntArray;
  sLongIntIO.Write1F := Write1FLongInt;
  sLongIntIO.Write2F := Write2FLongInt;
  sLongIntIO.Write3F := Write3FLongInt;

  sLongRealIO.Read := ReadLongReal;
  sLongRealIO.Write := WriteLongReal;
  sLongRealIO.WriteF := WriteFLongReal;
  sLongRealIO.ReadArray := ReadLongRealArray;
  sLongRealIO.WriteArray := WriteLongRealArray;
  sLongRealIO.WriteFArray := WriteFLongRealArray;
  sLongRealIO.Write1F := Write1FLongReal;
  sLongRealIO.Write2F := Write2FLongReal;
  sLongRealIO.Write3F := Write3FLongReal;

  sRealIO.Read := ReadReal;
  sRealIO.Write := WriteReal;
  sRealIO.WriteF := WriteFReal;
  sRealIO.ReadArray := ReadRealArray;
  sRealIO.WriteArray := WriteRealArray;
  sRealIO.WriteFArray := WriteFRealArray;
  sRealIO.Write1F := Write1FReal;
  sRealIO.Write2F := Write2FReal;
  sRealIO.Write3F := Write3FReal;

END IOSupport.

