IMPLEMENTATION MODULE LowIOSupport;

IMPORT StdIO;
IMPORT UNSAFE; FROM UNSAFE IMPORT ADDRESS, BYTE, WORD;

IMPORT AddressBaseIO, AddressArrayIO;
(* Imports IO modules for predefined type ADDRESS into the importing module. *)
IMPORT ByteBaseIO, ByteArrayIO;
(* Imports IO modules for predefined type BYTE into the importing module. *)
IMPORT WordBaseIO, WordArrayIO;
(* Imports IO modules for predefined type WORD into the importing module. *)
IMPORT BitsetBaseIO, BitsetArrayIO;
(* Imports IO modules for predefined type BITSET into the importing module. *)

(* Now set up the oIO for standard channels using s prefix. Not needed when the  default is ready. *)(* Address section *)

PROCEDURE ReadAddress ( VAR a : ADDRESS);

BEGIN
  AddressBaseIO.Read (StdIO.in(), a)
END ReadAddress;


PROCEDURE WriteAddress ( a : ADDRESS);

BEGIN
  AddressBaseIO.Write (StdIO.out(), a)
END WriteAddress;


PROCEDURE WriteFAddress ( fmtArray : ARRAY OF CHAR; adrs : ARRAY OF ADDRESS);

BEGIN
  AddressBaseIO.WriteF (StdIO.out(), fmtArray, adrs)
END WriteFAddress;


PROCEDURE ReadAddressArray ( VAR adrs : ARRAY OF ADDRESS );

BEGIN
  AddressArrayIO.ReadArray (StdIO.in(), adrs)
END ReadAddressArray;


PROCEDURE WriteAddressArray ( adrs : ARRAY OF ADDRESS);

BEGIN
  AddressArrayIO.WriteArray (StdIO.out(), adrs)
END WriteAddressArray;


PROCEDURE WriteFAddressArray ( fmtArray : ARRAY OF CHAR; adrs : (*ARGLIST >0*) ARRAY OF ARRAY OF ADDRESS );

BEGIN
  AddressArrayIO.WriteFArray (StdIO.out(), fmtArray, adrs)
END WriteFAddressArray;

(*End Address section *)

(* BYTE section *)

PROCEDURE ReadByte ( VAR b : BYTE);

BEGIN
  ByteBaseIO.Read (StdIO.in(), b)
END ReadByte;


PROCEDURE WriteByte ( b : BYTE);

BEGIN
  ByteBaseIO.Write (StdIO.out(), b)
END WriteByte;


PROCEDURE WriteFByte ( fmtArray : ARRAY OF CHAR; bytes : ARRAY OF BYTE);

BEGIN
  ByteBaseIO.WriteF (StdIO.out(), fmtArray, bytes)
END WriteFByte;


PROCEDURE ReadByteArray ( VAR bytes : ARRAY OF BYTE );

BEGIN
  ByteArrayIO.ReadArray (StdIO.in(), bytes)
END ReadByteArray;


PROCEDURE WriteByteArray ( bytes : ARRAY OF BYTE);

BEGIN
  ByteArrayIO.WriteArray (StdIO.out(), bytes)
END WriteByteArray;


PROCEDURE WriteFByteArray ( fmtArray : ARRAY OF CHAR; bytes : (*ARGLIST >0*) ARRAY OF ARRAY OF BYTE );

BEGIN
  ByteArrayIO.WriteFArray (StdIO.out(), fmtArray, bytes)
END WriteFByteArray;


(* Word section *)


PROCEDURE ReadWord ( VAR w : WORD);

BEGIN
  WordBaseIO.Read (StdIO.in(), w)
END ReadWord;


PROCEDURE WriteWord ( w : WORD);

BEGIN
  WordBaseIO.Write (StdIO.out(), w)
END WriteWord;


PROCEDURE WriteFWord ( fmtArray : ARRAY OF CHAR; words : ARRAY OF WORD);

BEGIN
  WordBaseIO.WriteF (StdIO.out(), fmtArray, words)
END WriteFWord;


PROCEDURE ReadWordArray ( VAR words : ARRAY OF WORD );

BEGIN
  WordArrayIO.ReadArray (StdIO.in(), words)
END ReadWordArray;


PROCEDURE WriteWordArray ( words : ARRAY OF WORD);

BEGIN
  WordArrayIO.WriteArray (StdIO.out(), words)
END WriteWordArray;


PROCEDURE WriteFWordArray ( fmtArray : ARRAY OF CHAR; words : (*ARGLIST >0*) ARRAY OF ARRAY OF WORD );

BEGIN
  WordArrayIO.WriteFArray (StdIO.out(), fmtArray, words)
END WriteFWordArray;

(*End Word section *)

(* Bitset section *)


PROCEDURE ReadBitset ( VAR bs : BITSET);

BEGIN
  BitsetBaseIO.Read (StdIO.in(), bs)
END ReadBitset;


PROCEDURE WriteBitset ( bs : BITSET);

BEGIN
  BitsetBaseIO.Write (StdIO.out(), bs)
END WriteBitset;


PROCEDURE WriteFBitset ( fmtArray : ARRAY OF CHAR; bits : ARRAY OF BITSET);

BEGIN
  BitsetBaseIO.WriteF (StdIO.out(), fmtArray, bits)
END WriteFBitset;


PROCEDURE ReadBitsetArray ( VAR bits : ARRAY OF BITSET );

BEGIN
  BitsetArrayIO.ReadArray (StdIO.in(), bits)
END ReadBitsetArray;


PROCEDURE WriteBitsetArray ( bits : ARRAY OF BITSET);

BEGIN
  BitsetArrayIO.WriteArray (StdIO.out(), bits)
END WriteBitsetArray;


PROCEDURE WriteFBitsetArray ( fmtArray : ARRAY OF CHAR; bits : (*ARGLIST >0*) ARRAY OF ARRAY OF BITSET );

BEGIN
  BitsetArrayIO.WriteFArray (StdIO.out(), fmtArray, bits)
END WriteFBitsetArray;

(*End Bitset section *)


BEGIN (* main module *)
  (* fill in methods for the one with file params *)
  AddressIO.Read := AddressBaseIO.Read;
  AddressIO.Write := AddressBaseIO.Write;
  AddressIO.WriteF := AddressBaseIO.WriteF;
  AddressIO.ReadArray := AddressArrayIO.ReadArray;
  AddressIO.WriteArray := AddressArrayIO.WriteArray;
  AddressIO.WriteFArray := AddressArrayIO.WriteFArray;

  ByteIO.Read := ByteBaseIO.Read;
  ByteIO.Write := ByteBaseIO.Write;
  ByteIO.WriteF := ByteBaseIO.WriteF;
  ByteIO.ReadArray := ByteArrayIO.ReadArray;
  ByteIO.WriteArray := ByteArrayIO.WriteArray;
  ByteIO.WriteFArray := ByteArrayIO.WriteFArray;

  WordIO.Read := WordBaseIO.Read;
  WordIO.Write := WordBaseIO.Write;
  WordIO.WriteF := WordBaseIO.WriteF;
  WordIO.ReadArray := WordArrayIO.ReadArray;
  WordIO.WriteArray := WordArrayIO.WriteArray;
  WordIO.WriteFArray := WordArrayIO.WriteFArray;

  BitsetIO.Read := BitsetBaseIO.Read;
  BitsetIO.Write := BitsetBaseIO.Write;
  BitsetIO.WriteF := BitsetBaseIO.WriteF;
  BitsetIO.ReadArray := BitsetArrayIO.ReadArray;
  BitsetIO.WriteArray := BitsetArrayIO.WriteArray;
  BitsetIO.WriteFArray := BitsetArrayIO.WriteFArray;

  (* fill in methods for the one without file params *)
  sAddressIO.Read := ReadAddress;
  sAddressIO.Write := WriteAddress;
  sAddressIO.WriteF := WriteFAddress;
  sAddressIO.ReadArray := ReadAddressArray;
  sAddressIO.WriteArray := WriteAddressArray;
  sAddressIO.WriteFArray := WriteFAddressArray;

  sByteIO.Read := ReadByte;
  sByteIO.Write := WriteByte;
  sByteIO.WriteF := WriteFByte;
  sByteIO.ReadArray := ReadByteArray;
  sByteIO.WriteArray := WriteByteArray;
  sByteIO.WriteFArray := WriteFByteArray;

  sWordIO.Read := ReadWord;
  sWordIO.Write := WriteWord;
  sWordIO.WriteF := WriteFWord;
  sWordIO.ReadArray := ReadWordArray;
  sWordIO.WriteArray := WriteWordArray;
  sWordIO.WriteFArray := WriteFWordArray;

  sBitsetIO.Read := ReadBitset;
  sBitsetIO.Write := WriteBitset;
  sBitsetIO.WriteF := WriteFBitset;
  sBitsetIO.ReadArray := ReadBitsetArray;
  sBitsetIO.WriteArray := WriteBitsetArray;
  sBitsetIO.WriteFArray := WriteFBitsetArray;

END LowIOSupport.

