(* (C) 2016 by B.Kowarsch & R.Sutcliffe. All rights reserved. *)

IMPLEMENTATION MODULE CharArrayFIO (*[ProtoArrayIO] FOR CHAR*);

(* IO Extension Library for Array Types of CHAR *)

IMPORT SYSTEM;
FROM Transition IMPORT CAPACITYo, CAPACITYao;
FROM Transition IMPORT OCTET;

(* R10 Stuff *)
IMPORT FilePtrIO, CharBaseFIO, CharStrFIO, Perror, ISO646;
IMPORT IOStatus; FROM IOStatus IMPORT IOStatusT;

(* RS Stuff *)
IMPORT FormatIO;
IMPORT ARRAYOFCHAR, CharArray;

CONST
  ScanStrForFormat = FormatIO.ScanStrForFormat;
  FormatNumStr = FormatIO.FormatNumStr;
  FormatTextStr = FormatIO.FormatTextStr;

TYPE
  FormatScanRec = FormatIO.FormatScanRec;


PROCEDURE (*[READ]*) ReadArray
  ( infile : FilePtrIO.File; VAR array : ARRAY OF CHAR );

VAR
  count : CARDINAL;
  status : IOStatusT;

BEGIN
  count := 0;
  WHILE count < CAPACITYo (array) DO
    CharBaseFIO.Read (infile, array [count] );
    status := FilePtrIO.statusOf (infile);
    count := count + 1;
    IF NOT status.failed THEN RETURN END
  END (* while *)
END ReadArray;


PROCEDURE (*[WRITE]*) WriteArray
  ( outfile : FilePtrIO.File; (*CONST*) array : ARRAY OF CHAR );

VAR
  count, counta : CARDINAL;

BEGIN
  count := 0;
  counta := CAPACITYo (array);
  WHILE count < counta DO
    CharBaseFIO.Write (outfile, '"' );
    CharBaseFIO.Write (outfile, array [count] );
    CharBaseFIO.Write (outfile, '"' );
    IF count < CAPACITYo (array) - 1 THEN CharBaseFIO.Write (outfile, ' ' ) END;
    count := count + 1
  END (* while *)
END WriteArray;


PROCEDURE WriteFWithfsr ( outfile : FilePtrIO.File; fsr : FormatScanRec; items :  ARRAY OF ARRAY OF CHAR );
(* come here to write out the items after the fmtStr results have been scanned to an fsr *)
VAR
  temp : FormatIO.Str;
  count, last, colCount : CARDINAL;

BEGIN
  last := CAPACITYao (items) - 1;
  colCount := 0;

    (* open an array enclosure if needed *)
  IF fsr.isArrayFormat THEN
    CharStrFIO.WriteStr (outfile, fsr.arrayOpenStr)
  END; (* if *) 

  (* now loop through the items *)
  count := 0;
  WHILE count <= last DO
    temp[0] := ISO646.NUL;
    ARRAYOFCHAR.Concat (temp, items[count], temp);
       (* format that char using the fsr already parsed *)
    temp :=  FormatTextStr (temp, fsr);

       (* write out the formatted string *)
    WriteArray (outfile, temp);

          (* and the separator *)
    IF ((fsr.isArrayFormat) OR NOT fsr.isConcat) AND (count # last) THEN
      CharStrFIO.WriteStr (outfile, fsr.arrayItemSeperator)
    END; (* if *)

       (* deal with columns *)
    IF fsr.isColumnFormat THEN
      colCount := (colCount + 1) MOD fsr.numCols;
      IF (colCount = 0) AND (count # last) THEN CharStrFIO.WriteStr ( outfile, "\n" ) END
    END (* if *);
    count := count + 1
  END(* while *);


  (* close the array if needed *)
  IF fsr.isArrayFormat THEN
    CharStrFIO.WriteStr (outfile, fsr.arrayCloseStr)
  END; (* if *)
  (* and if an escaped char is in the fsr, write it *)
  CharStrFIO.WriteStr (outfile, fsr.terminalEscStr) (* if any *)

END WriteFWithfsr;


PROCEDURE (*[WRITEF]*) WriteFArray
  ( outfile : FilePtrIO.File;
    (*CONST*) fmtStr : ARRAY OF CHAR;
    (*CONST*) arrays : (*ARGLIST >0*) ARRAY OF ARRAY OF CHAR );

VAR
  fsr : FormatScanRec;

BEGIN
   (* get the format string scanned to a format string record *)
    ScanStrForFormat (fmtStr, FormatIO.CharScanSet, FormatIO.ValidCharFmtChars, fsr);
    WriteFWithfsr ( outfile, fsr , arrays  )

END WriteFArray;

END CharArrayFIO.