(* (C) 2016 by B.Kowarsch & R.Sutcliffe. All rights reserved." *)

IMPLEMENTATION MODULE IOStatus;

PROCEDURE fetchMsg ( status : IOStatus; VAR msg : statusMsg );
(* returns the stored message for the passed code" *)

BEGIN
  IF (status.code = Success) AND NOT (status.failed)
    OR (status.code # Success) AND (status.failed)
    THEN (* status is valid so go ahead *)
      CASE status.code OF
        Success :
          msg := "The IO operation succeeded."
       | Failure :
          msg := "The IO operation Failed."
       | FileNotFound :
          msg := "No file found with this filename."
       | InvalidFile :
          msg := "Invalid accessor/handle/descriptor."
       | NameTooLong :
          msg := "The passed filename is too long."
       | IllegalCharsInName :
          msg := "Illegal chars in passed filename."
       | InvalidMode :
          msg := "The passed mode is invalid."
       | AlreadyOpen :
          msg := "The passed file is already open."
       | AlreadyExists :
          msg := "Attempt to create existing file."
       | MayNotOpenDirectory :
          msg := "Attempt to open a directory."
       | AccessDenied :
          msg := "The filesystem denied file access."
       | AccessBeyondEOF :
          msg := "Attempt to read past end of file."
       | NotOpenForReading :
          msg := "File is not in Read mode."
       | NotOpenForWriting :
          msg := "File is not in Write/Append mode."
       | OutOfRange :
          msg := "Input data is out of target range."
       | WrongFormat :
          msg := "Input data is in unexpected format."
       | UnexpectedEndOfLine :
          msg := "Unexpected end-of-line in input."
       | UnexpectedEndOfInput :
          msg := "Unexpected end of input data."
       | ConnectionClosed :
          msg := "Remote end closed the connection."
       | InvalidFilePos :
          msg := "Attempt to set a invalid position "
       | InsertBufferFull :
          msg := "Capacity of insert buffer exceeded."
       | FileSizeLimitExceeded :
          msg := "Attempt to write past size limit."
       | OpenFileLimitExceeded :
          msg := "Attempt to open too many files."
       | OperationNotSupported :
          msg := "Unsupported operation attempted."
       | AllocationFailed :
          msg := "Attempt to allocate space failed."
       | DeviceFull :
          msg := "The device capacity is exceeded."
       | DeviceError :
          msg := "The device reported a failure."
      END; (* case *)
  ELSE (* for the if *)
    msg := "The status passed to fetchMsg is invalid "
  END; (* if *)
END fetchMsg;

END IOStatus.