IMPLEMENTATION MODULE UNSAFE;

IMPORT SYSTEM;
IMPORT Transition; FROM Transition IMPORT SET64, CAPACITYo;
(* utility Proc *)

PROCEDURE CastOcts (input : ARRAY OF OCTET; VAR output : ARRAY OF OCTET);

VAR
  Count, InputCount, OutputCount : CARDINAL;

BEGIN
  OutputCount := CAPACITYo ( output );
  InputCount := CAPACITYo ( input );
  Count := 0;
  WHILE ( Count < InputCount ) AND ( Count < OutputCount ) DO
    output [ Count ] := input [ Count ];
    Count := Count + 1
  END
END CastOcts;


(* Exported Procs *)


PROCEDURE BIT ( value : ARRAY OF OCTET; bitIndex : CARDINAL ) : BOOLEAN;

VAR
  bSet : SET64;
  
BEGIN
  bSet := SYSTEM.CAST ( SET64, value );
  RETURN bitIndex IN bSet

END BIT;


PROCEDURE SETBIT ( VAR target : ARRAY OF OCTET; bitIndex : CARDINAL; bit : BOOLEAN );

VAR
  bSet : SET64;
  
BEGIN
  bSet := SYSTEM.CAST ( SET64, target );
  IF bit THEN
    INCL (bSet, bitIndex)
  ELSE
    EXCL (bSet, bitIndex)
  END;
  CastOcts (bSet, target);

END SETBIT;

(* Bit tests *)

PROCEDURE LSBIT ( x : ARRAY OF OCTET ) : CARDINAL;
(* Returns the position of the least significant set bit of x. *)

VAR
  bSet : SET64;
  bitIndex : CARDINAL;
  
BEGIN
  bSet := SYSTEM.CAST ( SET64, x );
  IF bSet = SET64{} THEN RETURN 64 END;
  bitIndex := 0;
  WHILE NOT (bitIndex IN bSet) DO
    bitIndex := bitIndex + 1;
  END; (* While *)
  RETURN bitIndex  

END LSBIT;

PROCEDURE MSBIT ( x : ARRAY OF OCTET ) : CARDINAL;
(* Returns the position of the most significant set bit of x. *)

VAR
  bSet : SET64;
  bitIndex : CARDINAL;
  
BEGIN
  bSet := SYSTEM.CAST ( SET64, x );
  IF bSet = SET64{} THEN RETURN 64 END;
  bitIndex := 63;
  WHILE NOT (bitIndex IN bSet) DO
    bitIndex := bitIndex - 1;
  END; (* While *)
  RETURN bitIndex  
END MSBIT;


PROCEDURE CTZ ( x : ARRAY OF OCTET ) : CARDINAL;
(* Returns the number of trailing zeros in the bit representation of x *)
  
BEGIN
  RETURN LSBIT (x)

END CTZ;


PROCEDURE CLZ ( x : ARRAY OF OCTET ) : CARDINAL;
(* Returns the number of leading zeros in the bit representation of x *)

VAR
  b0 : CARDINAL;

BEGIN
  b0 := MSBIT (x);
  IF b0 = 64 THEN
    RETURN 64
  ELSE
    RETURN 63 - b0  
  END (* if *)
END CLZ;

END UNSAFE.